--local presetJSON = require "preset"
local function DecodeParams(p_Table)
    if p_Table == nil then
        print("No table received")
        return false
	end
	for s_Key, s_Value in pairs(p_Table) do
		if s_Key == 'transform' or s_Key == 'localTransform'then
			local s_LinearTransform = LinearTransform(
					Vec3(s_Value.left.x, s_Value.left.y, s_Value.left.z),
					Vec3(s_Value.up.x, s_Value.up.y, s_Value.up.z),
					Vec3(s_Value.forward.x, s_Value.forward.y, s_Value.forward.z),
					Vec3(s_Value.trans.x, s_Value.trans.y, s_Value.trans.z))

			p_Table[s_Key] = s_LinearTransform

		elseif type(s_Value) == "table" then
			p_Table[s_Key] = DecodeParams(s_Value)
		end

	end

	return p_Table
end


local m_Preset = nil
Events:Subscribe('Extension:Loaded', function()
if SharedUtils:GetLevelName() ~= 'Levels/XP2_Skybar/XP2_Skybar' then
	return
	end
	if m_Preset ~= nil then
		print("Loaded preset: " .. m_Preset.header.projectName)
		g_CustomLevelData = m_Preset
	end
end)

Events:Subscribe('MapLoader-Villa:LoadLevel', function(p_SaveFile)
if SharedUtils:GetLevelName() ~= 'Levels/XP2_Skybar/XP2_Skybar' then
	return
	end
	m_Preset = p_SaveFile
	g_CustomLevelData = m_Preset
	print("Got savefile: " .. m_Preset.header.projectName)
end)

NetEvents:Subscribe('MapLoader-Villa:GetLevel', function(p_Player)
if SharedUtils:GetLevelName() ~= 'Levels/XP2_Skybar/XP2_Skybar' then
	return
	end
	print('Sending level to ' .. p_Player.name)
	NetEvents:SendTo('MapLoader-Villa:GetLevel', p_Player, g_CustomLevelData)
end)

